package it.polito.bigdata.hadoop;

import org.apache.hadoop.io.DoubleWritable;
import org.apache.hadoop.io.NullWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;

import java.io.IOException;

public class Reducer2BigData extends Reducer<
                                    Text,
                                    DoubleWritable,
                                    Text,
                                    NullWritable> {
    private String cidMax;
    private double avgMax;

    @Override
    protected void setup(Context context) throws IOException, InterruptedException {
        cidMax = "";
        avgMax = -1;
    }

    @Override
    protected void reduce(Text key, Iterable<DoubleWritable> values, Context context) throws IOException, InterruptedException {
        double avg = 0;
        String cid = key.toString();
        for(DoubleWritable v : values)
            avg += v.get();

        if(avg > avgMax || (avg == avgMax && cid.compareTo(cidMax) < 0)) {
            avgMax = avg;
            cidMax = cid;
        }
    }

    @Override
    protected void cleanup(Context context) throws IOException, InterruptedException {
        context.write(new Text(cidMax), NullWritable.get());
    }
}
